/*******************************************************************
*
*  DESCRIPTION: class Contador
*
*  AUTHOR: 
*
*
*  DATE: 
*
*******************************************************************/

#ifndef __CONTADOR_H
#define __CONTADOR_H

#include <map.h>
#include "atomic.h"
#include "message.h"

class contador: public Atomic
{
public:
	contador( const string &name = "contador" ) ;	//Default constructor

	virtual string className() const ;

protected:
	Model &initFunction();
	Model &externalFunction( const ExternalMessage & );
	Model &internalFunction( const InternalMessage & );
	Model &outputFunction( const InternalMessage & );

private:
	const Port &arrived ;
	const Port &solved ;

	Port &throughputA;
	Port &throughputS;
      

	Time frec ;
	Time tUnit ;
	long arrivedCount ;
	long solvedCount ;

	const Time &frecuence() const ;
	const Time &timeUnit() const ;

};	// class Contador

// ** inline ** // 
inline
string contador::className() const
{
	return "contador" ;
}

inline
const Time &contador::frecuence() const
{
	return frec ;
}


inline
const Time &contador::timeUnit() const
{
	return tUnit ;
}

#endif   //__CONTADOR_H 
