/*******************************************************************
*
*  DESCRIPTION: Simulator::registerNewAtomics()
*
*  AUTHOR: Amir Barylko & Jorge Beyoglonian 
*
*  EMAIL: mailto://amir@dc.uba.ar
*         mailto://jbeyoglo@dc.uba.ar
*
*  DATE: 27/6/1998
*
*******************************************************************/

#include "modeladm.h" 
#include "mainsimu.h"
#include "generat.h"    // class Generator
#include "congest.h"    // class congestion
#include "contador.h"    // class contador
#include "od.h"    // class od

void MainSimulator::registerNewAtomics()
{
	SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<Generator>() , "Generator" ) ;
	SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<congestion>() , "congestion" ) ;
	SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<od>() , "od" ) ;
	SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<contador>() , "contador" ) ;
}
